Fix typo in the DRBD parser types file
[ganeti-local] / Makefile.am
index 9977926..871f73f 100644 (file)
@@ -23,6 +23,7 @@ RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
 CHECK_HEADER = $(top_srcdir)/autotools/check-header
 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
+CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
 CHECK_VERSION = $(top_srcdir)/autotools/check-version
 CHECK_NEWS = $(top_srcdir)/autotools/check-news
@@ -31,6 +32,7 @@ DOCPP = $(top_srcdir)/autotools/docpp
 REPLACE_VARS_SED = autotools/replace_vars.sed
 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
+SHELL_ENV_INIT = autotools/shell-env-init
 
 # Note: these are automake-specific variables, and must be named after
 # the directory + 'dir' suffix
@@ -53,25 +55,43 @@ myexeclibdir = $(pkglibdir)
 # Delete output file if an error occurred while building it
 .DELETE_ON_ERROR:
 
-HTOOLS_DIRS = \
-       htools \
-       htools/Ganeti \
-       htools/Ganeti/Confd \
-       htools/Ganeti/HTools \
-       htools/Ganeti/HTools/Program
+HS_DIRS = \
+       src \
+       src/Ganeti \
+       src/Ganeti/Block \
+       src/Ganeti/Block/Drbd \
+       src/Ganeti/Confd \
+       src/Ganeti/DataCollectors \
+       src/Ganeti/HTools \
+       src/Ganeti/HTools/Backend \
+       src/Ganeti/HTools/Program \
+       src/Ganeti/Query \
+       test/hs \
+       test/hs/Test \
+       test/hs/Test/Ganeti \
+       test/hs/Test/Ganeti/Block \
+       test/hs/Test/Ganeti/Block/Drbd \
+       test/hs/Test/Ganeti/Confd \
+       test/hs/Test/Ganeti/HTools \
+       test/hs/Test/Ganeti/HTools/Backend \
+       test/hs/Test/Ganeti/Query
 
 DIRS = \
+       $(HS_DIRS) \
        autotools \
        daemons \
        devel \
        doc \
+       doc/css \
        doc/examples \
-       doc/examples/hooks \
        doc/examples/gnt-debug \
-       $(HTOOLS_DIRS) \
+       doc/examples/hooks \
+       test/data/htools \
+       test/data/htools/rapi \
+       test/hs/shelltests \
        lib \
-       lib/client \
        lib/build \
+       lib/client \
        lib/confd \
        lib/http \
        lib/hypervisor \
@@ -86,24 +106,31 @@ DIRS = \
        qa \
        test \
        test/data \
-       test/data/htools \
-       test/data/htools/rapi \
        test/data/ovfdata \
        test/data/ovfdata/other \
+       test/py \
        tools
 
-BUILDTIME_DIR_AUTOCREATE = \
-       scripts \
-       $(APIDOC_DIR) \
-       $(APIDOC_PY_DIR) \
+ALL_APIDOC_HS_DIRS = \
        $(APIDOC_HS_DIR) \
        $(APIDOC_HS_DIR)/Ganeti \
+       $(APIDOC_HS_DIR)/Ganeti/Block \
+       $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
        $(APIDOC_HS_DIR)/Ganeti/Confd \
+       $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
        $(APIDOC_HS_DIR)/Ganeti/HTools \
+       $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
        $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
+       $(APIDOC_HS_DIR)/Ganeti/Query
+
+BUILDTIME_DIR_AUTOCREATE = \
+       scripts \
+       $(APIDOC_DIR) \
+       $(ALL_APIDOC_HS_DIRS) \
+       $(APIDOC_PY_DIR) \
        $(COVERAGE_DIR) \
-       $(COVERAGE_PY_DIR) \
        $(COVERAGE_HS_DIR) \
+       $(COVERAGE_PY_DIR) \
        .hpc
 
 BUILDTIME_DIRS = \
@@ -113,9 +140,8 @@ BUILDTIME_DIRS = \
 DIRCHECK_EXCLUDE = \
        $(BUILDTIME_DIRS) \
        ganeti-[0-9]*.[0-9]*.[0-9]* \
-       doc/html/_*
-
-all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
+       doc/html/_* \
+       autom4te.cache
 
 # some helper vars
 COVERAGE_DIR = doc/coverage
@@ -126,7 +152,6 @@ APIDOC_PY_DIR = $(APIDOC_DIR)/py
 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
 
 MAINTAINERCLEANFILES = \
-       $(docpng) \
        $(maninput) \
        doc/install-quick.rst \
        doc/news.rst \
@@ -138,39 +163,47 @@ maintainer-clean-local:
 
 CLEANFILES = \
        $(addsuffix /*.py[co],$(DIRS)) \
-       $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
-       $(addsuffix /*.o,$(HTOOLS_DIRS)) \
-       $(all_dirfiles) \
+       $(addsuffix /*.hi,$(HS_DIRS)) \
+       $(addsuffix /*.o,$(HS_DIRS)) \
        $(PYTHON_BOOTSTRAP) \
        epydoc.conf \
-       autotools/replace_vars.sed \
+       $(REPLACE_VARS_SED) \
+       $(SHELL_ENV_INIT) \
        daemons/daemon-util \
        daemons/ganeti-cleaner \
-       devel/upload \
        $(BUILT_EXAMPLES) \
        doc/examples/bash_completion \
+       doc/examples/bash_completion-debug \
        lib/_generated_rpc.py \
        $(man_MANS) \
        $(manhtml) \
        tools/kvm-ifup \
+       tools/vcluster-setup \
+       stamp-directories \
        stamp-srclinks \
        $(nodist_pkgpython_PYTHON) \
        $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
        $(HS_BUILT_TEST_HELPERS) \
-       .hpc/*.mix htools/*.tix \
+       src/ganeti-confd \
+       .hpc/*.mix src/*.tix test/hs/*.tix \
        doc/hs-lint.html
 
-# BUILT_SOURCES should only be used as a dependency on phony
-# targets. Otherwise it'll cause the target to rebuild every time.
-BUILT_SOURCES = \
-  $(built_base_sources) \
+GENERATED_FILES = \
+       $(built_base_sources) \
        $(BUILT_PYTHON_SOURCES) \
        $(PYTHON_BOOTSTRAP)
 
+HS_GENERATED_FILES =
+if WANT_HTOOLS
+HS_GENERATED_FILES += $(HS_PROGS)
+if ENABLE_CONFD
+HS_GENERATED_FILES += src/hconfd src/ganeti-confd
+endif
+endif
+
 built_base_sources = \
-       ganeti \
-       stamp-srclinks \
-       $(all_dirfiles)
+       stamp-directories \
+       stamp-srclinks
 
 built_python_base_sources = \
        lib/_autoconf.py \
@@ -180,8 +213,8 @@ BUILT_PYTHON_SOURCES = \
        $(built_python_base_sources) \
        lib/_generated_rpc.py
 
-# Generating the RPC wrappers depends on many things, so make sure it's built at
-# the end of the built sources
+# Generating the RPC wrappers depends on many things, so make sure
+# it's built at the end of the built sources
 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
 
 # these are all built from the underlying %.in sources
@@ -189,6 +222,8 @@ BUILT_EXAMPLES = \
        doc/examples/ganeti-kvm-poweroff.initd \
        doc/examples/ganeti.cron \
        doc/examples/ganeti.initd \
+       doc/examples/ganeti-master-role.ocf \
+       doc/examples/ganeti-node-role.ocf \
        doc/examples/gnt-config-backup \
        doc/examples/hooks/ipsec
 
@@ -197,8 +232,8 @@ nodist_pkgpython_PYTHON = \
 
 noinst_PYTHON = \
        lib/build/__init__.py \
-       lib/build/sphinx_ext.py \
-       lib/build/shell_example_lexer.py
+       lib/build/shell_example_lexer.py \
+       lib/build/sphinx_ext.py
 
 pkgpython_PYTHON = \
        lib/__init__.py \
@@ -221,8 +256,10 @@ pkgpython_PYTHON = \
        lib/mcpu.py \
        lib/netutils.py \
        lib/objects.py \
+       lib/objectutils.py \
        lib/opcodes.py \
        lib/ovf.py \
+       lib/pathutils.py \
        lib/qlang.py \
        lib/query.py \
        lib/rpc.py \
@@ -233,6 +270,8 @@ pkgpython_PYTHON = \
        lib/ssh.py \
        lib/storage.py \
        lib/uidpool.py \
+       lib/vcluster.py \
+       lib/network.py \
        lib/workerpool.py
 
 client_PYTHON = \
@@ -244,7 +283,9 @@ client_PYTHON = \
        lib/client/gnt_instance.py \
        lib/client/gnt_job.py \
        lib/client/gnt_node.py \
-       lib/client/gnt_os.py
+       lib/client/gnt_network.py \
+       lib/client/gnt_os.py \
+       lib/client/gnt_storage.py
 
 hypervisor_PYTHON = \
        lib/hypervisor/__init__.py \
@@ -272,12 +313,11 @@ http_PYTHON = \
 
 confd_PYTHON = \
        lib/confd/__init__.py \
-       lib/confd/client.py \
-       lib/confd/querylib.py \
-       lib/confd/server.py
+       lib/confd/client.py
 
 masterd_PYTHON = \
        lib/masterd/__init__.py \
+       lib/masterd/iallocator.py \
        lib/masterd/instance.py
 
 impexpd_PYTHON = \
@@ -290,14 +330,16 @@ watcher_PYTHON = \
 
 server_PYTHON = \
        lib/server/__init__.py \
-       lib/server/confd.py \
        lib/server/masterd.py \
        lib/server/noded.py \
        lib/server/rapi.py
 
 pytools_PYTHON = \
        lib/tools/__init__.py \
-       lib/tools/ensure_dirs.py
+       lib/tools/ensure_dirs.py \
+       lib/tools/node_cleanup.py \
+       lib/tools/node_daemon_setup.py \
+       lib/tools/prepare_node_join.py
 
 utils_PYTHON = \
        lib/utils/__init__.py \
@@ -306,6 +348,7 @@ utils_PYTHON = \
        lib/utils/hash.py \
        lib/utils/io.py \
        lib/utils/log.py \
+       lib/utils/lvm.py \
        lib/utils/mlock.py \
        lib/utils/nodesetup.py \
        lib/utils/process.py \
@@ -316,33 +359,40 @@ utils_PYTHON = \
 
 docrst = \
        doc/admin.rst \
+       doc/cluster-merge.rst \
        doc/design-2.0.rst \
        doc/design-2.1.rst \
        doc/design-2.2.rst \
        doc/design-2.3.rst \
-       doc/design-htools-2.3.rst \
        doc/design-2.4.rst \
        doc/design-2.5.rst \
        doc/design-2.6.rst \
-       doc/design-draft.rst \
-       doc/design-oob.rst \
+       doc/design-2.7.rst \
+       doc/design-autorepair.rst \
+       doc/design-bulk-create.rst \
+       doc/design-chained-jobs.rst \
        doc/design-cpu-pinning.rst \
-       doc/design-query2.rst \
-       doc/design-x509-ca.rst \
+       doc/design-draft.rst \
+       doc/design-htools-2.3.rst \
        doc/design-http-server.rst \
        doc/design-impexp2.rst \
        doc/design-lu-generated-jobs.rst \
+       doc/design-linuxha.rst \
        doc/design-multi-reloc.rst \
        doc/design-network.rst \
-       doc/design-chained-jobs.rst \
+       doc/design-node-add.rst \
+       doc/design-oob.rst \
        doc/design-ovf-support.rst \
-       doc/design-autorepair.rst \
+       doc/design-opportunistic-locking.rst \
+       doc/design-partitioned.rst \
+       doc/design-query-splitting.rst \
+       doc/design-query2.rst \
+       doc/design-remote-commands.rst \
        doc/design-resource-model.rst \
-       doc/cluster-merge.rst \
        doc/design-shared-storage.rst \
-       doc/design-node-state-cache.rst \
+       doc/design-monitoring-agent.rst \
        doc/design-virtual-clusters.rst \
-       doc/design-query-splitting.rst \
+       doc/design-x509-ca.rst \
        doc/devnotes.rst \
        doc/glossary.rst \
        doc/hooks.rst \
@@ -357,84 +407,186 @@ docrst = \
        doc/rapi.rst \
        doc/security.rst \
        doc/upgrade.rst \
+       doc/virtual-cluster.rst \
        doc/walkthrough.rst
 
-HS_PROGS = htools/htools
-HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
+# Haskell programs to be installed in $PREFIX/bin
+HS_BIN_PROGS=src/htools
+
+# Haskell programs to be installed in the MYEXECLIB dir
+HS_MYEXECLIB_PROGS=src/mon-collector
+
+# Haskell programs to compiled but not installed automatically
+# Usually they have their own specific installation rules
+HS_COMPILE_PROGS= \
+       src/hconfd \
+       src/rpc-test
+
+# All Haskell non-test programs to be compiled but not automatically installed
+HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
+
+HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
+HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
+
+HS_ALL_PROGS = \
+       $(HS_PROGS) \
+       test/hs/hpc-htools \
+       test/hs/hpc-mon-collector \
+       test/hs/htest \
+       $(HS_COMPILE_PROGS)
 
-HS_ALL_PROGS = $(HS_PROGS) htools/test htools/hpc-htools htools/hconfd
 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
-HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/%) test/hail
+HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
+
+HFLAGS = \
+       -O -Wall -Werror -isrc \
+       -fwarn-monomorphism-restriction \
+       -fwarn-tabs \
+       $(GHC_BYVERSION_FLAGS)
 
-HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
 HEXTRA =
-# internal extra flags (used for htools/test mainly)
+# internal extra flags (used for test/hs/htest mainly)
 HEXTRA_INT =
 # exclude options for coverage reports
 HPCEXCL = --exclude Main \
        --exclude Ganeti.Constants \
-       --exclude Ganeti.THH \
        --exclude Ganeti.HTools.QC \
-       --exclude Ganeti.HTools.QCHelper \
-       --exclude Ganeti.HTools.Version
+       --exclude Ganeti.THH \
+       --exclude Ganeti.Version \
+       --exclude Test.Ganeti.Attoparsec \
+       --exclude Test.Ganeti.TestCommon \
+       --exclude Test.Ganeti.TestHTools \
+       --exclude Test.Ganeti.TestHelper \
+       --exclude Test.Ganeti.TestImports \
+       $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
 
 HS_LIB_SRCS = \
-       htools/Ganeti/HTools/CLI.hs \
-       htools/Ganeti/HTools/Cluster.hs \
-       htools/Ganeti/HTools/Compat.hs \
-       htools/Ganeti/HTools/Container.hs \
-       htools/Ganeti/HTools/ExtLoader.hs \
-       htools/Ganeti/HTools/Group.hs \
-       htools/Ganeti/HTools/IAlloc.hs \
-       htools/Ganeti/HTools/Instance.hs \
-       htools/Ganeti/HTools/JSON.hs \
-       htools/Ganeti/HTools/Loader.hs \
-       htools/Ganeti/HTools/Luxi.hs \
-       htools/Ganeti/HTools/Node.hs \
-       htools/Ganeti/HTools/PeerMap.hs \
-       htools/Ganeti/HTools/QC.hs \
-       htools/Ganeti/HTools/QCHelper.hs \
-       htools/Ganeti/HTools/Rapi.hs \
-       htools/Ganeti/HTools/Simu.hs \
-       htools/Ganeti/HTools/Text.hs \
-       htools/Ganeti/HTools/Types.hs \
-       htools/Ganeti/HTools/Utils.hs \
-       htools/Ganeti/HTools/Program.hs \
-       htools/Ganeti/HTools/Program/Hail.hs \
-       htools/Ganeti/HTools/Program/Hbal.hs \
-       htools/Ganeti/HTools/Program/Hcheck.hs \
-       htools/Ganeti/HTools/Program/Hinfo.hs \
-       htools/Ganeti/HTools/Program/Hscan.hs \
-       htools/Ganeti/HTools/Program/Hspace.hs \
-       htools/Ganeti/BasicTypes.hs \
-       htools/Ganeti/Confd.hs \
-       htools/Ganeti/Confd/Server.hs \
-       htools/Ganeti/Config.hs \
-       htools/Ganeti/Daemon.hs \
-       htools/Ganeti/Hash.hs \
-       htools/Ganeti/Jobs.hs \
-       htools/Ganeti/Logging.hs \
-       htools/Ganeti/Luxi.hs \
-       htools/Ganeti/Objects.hs \
-       htools/Ganeti/OpCodes.hs \
-       htools/Ganeti/Runtime.hs \
-       htools/Ganeti/Ssconf.hs \
-       htools/Ganeti/THH.hs
-
-HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
+       src/Ganeti/Block/Drbd/Types.hs \
+       src/Ganeti/Block/Drbd/Parser.hs \
+       src/Ganeti/BasicTypes.hs \
+       src/Ganeti/Common.hs \
+       src/Ganeti/Compat.hs \
+       src/Ganeti/Confd/Client.hs \
+       src/Ganeti/Confd/Server.hs \
+       src/Ganeti/Confd/Types.hs \
+       src/Ganeti/Confd/Utils.hs \
+       src/Ganeti/Config.hs \
+       src/Ganeti/Daemon.hs \
+       src/Ganeti/DataCollectors/CLI.hs \
+       src/Ganeti/DataCollectors/Drbd.hs \
+       src/Ganeti/DataCollectors/Program.hs \
+       src/Ganeti/Errors.hs \
+       src/Ganeti/HTools/Backend/IAlloc.hs \
+       src/Ganeti/HTools/Backend/Luxi.hs \
+       src/Ganeti/HTools/Backend/Rapi.hs \
+       src/Ganeti/HTools/Backend/Simu.hs \
+       src/Ganeti/HTools/Backend/Text.hs \
+       src/Ganeti/HTools/CLI.hs \
+       src/Ganeti/HTools/Cluster.hs \
+       src/Ganeti/HTools/Container.hs \
+       src/Ganeti/HTools/ExtLoader.hs \
+       src/Ganeti/HTools/Graph.hs \
+       src/Ganeti/HTools/Group.hs \
+       src/Ganeti/HTools/Instance.hs \
+       src/Ganeti/HTools/Loader.hs \
+       src/Ganeti/HTools/Node.hs \
+       src/Ganeti/HTools/PeerMap.hs \
+       src/Ganeti/HTools/Program/Hail.hs \
+       src/Ganeti/HTools/Program/Hbal.hs \
+       src/Ganeti/HTools/Program/Hcheck.hs \
+       src/Ganeti/HTools/Program/Hinfo.hs \
+       src/Ganeti/HTools/Program/Hscan.hs \
+       src/Ganeti/HTools/Program/Hspace.hs \
+       src/Ganeti/HTools/Program/Hroller.hs \
+       src/Ganeti/HTools/Program/Main.hs \
+       src/Ganeti/HTools/Types.hs \
+       src/Ganeti/Hash.hs \
+       src/Ganeti/JQueue.hs \
+       src/Ganeti/JSON.hs \
+       src/Ganeti/Jobs.hs \
+       src/Ganeti/Logging.hs \
+       src/Ganeti/Luxi.hs \
+       src/Ganeti/Network.hs \
+       src/Ganeti/Objects.hs \
+       src/Ganeti/OpCodes.hs \
+       src/Ganeti/OpParams.hs \
+       src/Ganeti/Path.hs \
+       src/Ganeti/Query/Common.hs \
+       src/Ganeti/Query/Filter.hs \
+       src/Ganeti/Query/Group.hs \
+       src/Ganeti/Query/Job.hs \
+       src/Ganeti/Query/Language.hs \
+       src/Ganeti/Query/Node.hs \
+       src/Ganeti/Query/Query.hs \
+       src/Ganeti/Query/Server.hs \
+       src/Ganeti/Query/Types.hs \
+       src/Ganeti/Rpc.hs \
+       src/Ganeti/Runtime.hs \
+       src/Ganeti/Ssconf.hs \
+       src/Ganeti/THH.hs \
+       src/Ganeti/Types.hs \
+       src/Ganeti/Utils.hs
+
+HS_TEST_SRCS = \
+       test/hs/Test/Ganeti/Attoparsec.hs \
+       test/hs/Test/Ganeti/BasicTypes.hs \
+       test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
+       test/hs/Test/Ganeti/Block/Drbd/Types.hs \
+       test/hs/Test/Ganeti/Common.hs \
+       test/hs/Test/Ganeti/Confd/Types.hs \
+       test/hs/Test/Ganeti/Confd/Utils.hs \
+       test/hs/Test/Ganeti/Daemon.hs \
+       test/hs/Test/Ganeti/Errors.hs \
+       test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
+       test/hs/Test/Ganeti/HTools/Backend/Text.hs \
+       test/hs/Test/Ganeti/HTools/CLI.hs \
+       test/hs/Test/Ganeti/HTools/Cluster.hs \
+       test/hs/Test/Ganeti/HTools/Container.hs \
+       test/hs/Test/Ganeti/HTools/Graph.hs \
+       test/hs/Test/Ganeti/HTools/Instance.hs \
+       test/hs/Test/Ganeti/HTools/Loader.hs \
+       test/hs/Test/Ganeti/HTools/Node.hs \
+       test/hs/Test/Ganeti/HTools/PeerMap.hs \
+       test/hs/Test/Ganeti/HTools/Types.hs \
+       test/hs/Test/Ganeti/JSON.hs \
+       test/hs/Test/Ganeti/Jobs.hs \
+       test/hs/Test/Ganeti/JQueue.hs \
+       test/hs/Test/Ganeti/Luxi.hs \
+       test/hs/Test/Ganeti/Network.hs \
+       test/hs/Test/Ganeti/Objects.hs \
+       test/hs/Test/Ganeti/OpCodes.hs \
+       test/hs/Test/Ganeti/Query/Filter.hs \
+       test/hs/Test/Ganeti/Query/Language.hs \
+       test/hs/Test/Ganeti/Query/Query.hs \
+       test/hs/Test/Ganeti/Rpc.hs \
+       test/hs/Test/Ganeti/Ssconf.hs \
+       test/hs/Test/Ganeti/THH.hs \
+       test/hs/Test/Ganeti/TestCommon.hs \
+       test/hs/Test/Ganeti/TestHTools.hs \
+       test/hs/Test/Ganeti/TestHelper.hs \
+       test/hs/Test/Ganeti/Types.hs \
+       test/hs/Test/Ganeti/Utils.hs
+
+HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
+
+HS_BUILT_SRCS = \
+       test/hs/Test/Ganeti/TestImports.hs \
+       src/Ganeti/Constants.hs \
+       src/Ganeti/Version.hs
 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
 
-$(RUN_IN_TEMPDIR): | $(all_dirfiles)
+$(RUN_IN_TEMPDIR): | stamp-directories
 
 # Note: we use here an order-only prerequisite, as the contents of
 # _autoconf.py are not actually influencing the html build output: it
 # has to exist in order for the sphinx module to be loaded
 # successfully, but we certainly don't want the docs to be rebuilt if
 # it changes
-doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
+doc/html/index.html: $(docrst) doc/conf.py configure.ac \
        $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
        lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
+       doc/css/style.css \
        | $(BUILT_PYTHON_SOURCES)
        @test -n "$(SPHINX)" || \
            { echo 'sphinx-build' not found during configure; exit 1; }
@@ -443,6 +595,7 @@ doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
            -d . \
            -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
            -D release="$(PACKAGE_VERSION)" \
+           -D graphviz_dot="$(DOT)" \
            $(abs_top_srcdir)/doc $(CURDIR)/doc/html
        rm -f doc/html/.buildinfo doc/html/objects.inv
        touch $@
@@ -461,20 +614,13 @@ doc/install-quick.rst doc/news.rst doc/upgrade.rst:
          cat $<; \
        } > $@
 
-docdot = \
-       doc/arch-2.0.dot \
-       doc/design-2.1-lock-acquire.dot \
-       doc/design-2.1-lock-release.dot
-
-docpng = $(patsubst %.dot,%.png,$(docdot))
-
 # Things to build but not to install (add it to EXTRA_DIST if it should be
 # distributed)
 noinst_DATA = \
-       devel/upload \
        doc/html \
        $(BUILT_EXAMPLES) \
        doc/examples/bash_completion \
+       doc/examples/bash_completion-debug \
        $(manhtml)
 
 gnt_scripts = \
@@ -484,23 +630,24 @@ gnt_scripts = \
        scripts/gnt-group \
        scripts/gnt-instance \
        scripts/gnt-job \
+       scripts/gnt-network \
        scripts/gnt-node \
-       scripts/gnt-os
+       scripts/gnt-os \
+       scripts/gnt-storage
 
 PYTHON_BOOTSTRAP_SBIN = \
        daemons/ganeti-masterd \
        daemons/ganeti-noded \
-       daemons/ganeti-watcher \
        daemons/ganeti-rapi \
+       daemons/ganeti-watcher \
        $(gnt_scripts)
 
-if PY_CONFD
-PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
-endif
-
 PYTHON_BOOTSTRAP = \
        $(PYTHON_BOOTSTRAP_SBIN) \
-       tools/ensure-dirs
+       tools/ensure-dirs \
+       tools/node-cleanup \
+       tools/node-daemon-setup \
+       tools/prepare-node-join
 
 qa_scripts = \
        qa/__init__.py \
@@ -521,49 +668,42 @@ qa_scripts = \
 
 bin_SCRIPTS =
 if WANT_HTOOLS
-bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
+bin_SCRIPTS += $(HS_BIN_PROGS)
 install-exec-hook:
        @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
 # FIXME: this is a hardcoded logic, instead of auto-resolving
        $(LN_S) -f ../../../bin/htools \
-                  $(DESTDIR)$(iallocatorsdir)/hail
+         $(DESTDIR)$(iallocatorsdir)/hail
        for role in $(HS_BIN_ROLES); do \
-               $(LN_S) -f htools \
-                          $(DESTDIR)$(bindir)/$$role ; \
+         $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
        done
-if HS_CONFD
-       mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
-endif
 endif
 
-$(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
-       @if [ -z "$(HTOOLS)" ]; then \
-         echo "Error: htools compilation disabled at configure time" 1>&2 ;\
+$(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
+       @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
+         echo "Error: cannot run unittests without the development" \
+              " libraries (see devnotes.rst)" 1>&2; \
          exit 1; \
        fi
-       @BINARY=$(@:htools/%=%); \
-       if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
-         echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
-         exit 1; \
-       fi
-       rm -f $(@:htools/%=%).tix
-       BINARY=$(@:htools/%=%); $(GHC) --make \
+       @rm -f $(notdir $@).tix
+       $(GHC) --make \
          $(HFLAGS) \
-         $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
-         -osuf $$BINARY.o -hisuf $$BINARY.hi \
+         $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
+         -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
          $(HEXTRA) $(HEXTRA_INT) $@
        @touch "$@"
 
-# for the htools/test binary, we need to enable profiling/coverage
-htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
-       -fno-warn-monomorphism-restriction -fno-warn-orphans \
-       -fno-warn-missing-methods -fno-warn-unused-imports
+# for the test/hs/htest binary, we need to enable profiling/coverage
+test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
 
 # we compile the hpc-htools binary with the program coverage
-htools/hpc-htools: HEXTRA_INT=-fhpc
+test/hs/hpc-htools: HEXTRA_INT=-fhpc
+
+# we compile the hpc-mon-collector binary with the program coverage
+test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
 
 # test dependency
-htools/offline-tests.sh: htools/hpc-htools
+test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
 
 # rules for building profiling-enabled versions of the haskell
 # programs: hs-prof does the full two-step build, whereas
@@ -571,13 +711,21 @@ htools/offline-tests.sh: htools/hpc-htools
 # run before)
 .PHONY: hs-prof hs-prof-quick
 hs-prof:
-       $(MAKE) clean
-       $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
+       @if [ -z "$(TARGET)" ]; then \
+         echo "You need to define TARGET when running this rule" 1>&2; \
+         exit 1; \
+       fi
+       $(MAKE) $(AM_MAKEFLAGS) clean
+       $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
        rm -f $(HS_ALL_PROGS)
-       $(MAKE) hs-prof-quick
+       $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
 
 hs-prof-quick:
-       $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
+       @if [ -z "$(TARGET)" ]; then \
+         echo "You need to define TARGET when running this rule" 1>&2; \
+         exit 1; \
+       fi
+       $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
 
 dist_sbin_SCRIPTS = \
        tools/ganeti-listrunner
@@ -586,8 +734,11 @@ nodist_sbin_SCRIPTS = \
        $(PYTHON_BOOTSTRAP_SBIN) \
        daemons/ganeti-cleaner
 
-if HS_CONFD
-nodist_sbin_SCRIPTS += htools/hconfd
+if ENABLE_CONFD
+src/ganeti-confd: src/hconfd
+       cp -f $< $@
+
+nodist_sbin_SCRIPTS += src/ganeti-confd
 endif
 
 python_scripts = \
@@ -601,26 +752,35 @@ python_scripts = \
        tools/lvmstrap \
        tools/move-instance \
        tools/ovfconverter \
-       tools/setup-ssh \
        tools/sanitize-config
 
 dist_tools_SCRIPTS = \
        $(python_scripts) \
        tools/kvm-console-wrapper \
-       tools/xm-console-wrapper \
-       tools/master-ip-setup
+       tools/master-ip-setup \
+       tools/xen-console-wrapper
+
+nodist_tools_python_scripts = \
+       tools/node-cleanup
+
+nodist_tools_SCRIPTS = \
+       $(nodist_tools_python_scripts) \
+       tools/vcluster-setup
 
 pkglib_python_scripts = \
        daemons/import-export \
        tools/check-cert-expired
 
 nodist_pkglib_python_scripts = \
-       tools/ensure-dirs
+       tools/ensure-dirs \
+       tools/node-daemon-setup \
+       tools/prepare-node-join
 
 myexeclib_SCRIPTS = \
        daemons/daemon-util \
        tools/kvm-ifup \
-       $(pkglib_python_scripts)
+       $(pkglib_python_scripts) \
+       $(HS_MYEXECLIB_PROGS)
 
 nodist_myexeclib_SCRIPTS = \
        $(nodist_pkglib_python_scripts)
@@ -633,28 +793,30 @@ EXTRA_DIST = \
        autotools/build-bash-completion \
        autotools/build-rpc \
        autotools/check-header \
-       autotools/check-python-code \
        autotools/check-imports \
        autotools/check-man-dashes \
+       autotools/check-man-references \
        autotools/check-man-warnings \
        autotools/check-news \
+       autotools/check-python-code \
        autotools/check-tar \
        autotools/check-version \
        autotools/convert-constants \
        autotools/docpp \
-       autotools/gen-coverage \
+       autotools/gen-py-coverage \
        autotools/testrunner \
        autotools/wrong-hardcoded-paths \
        $(RUN_IN_TEMPDIR) \
        daemons/daemon-util.in \
        daemons/ganeti-cleaner.in \
        $(pkglib_python_scripts) \
-       devel/upload.in \
+       devel/upload \
+       devel/webserver \
        tools/kvm-ifup.in \
-       $(docdot) \
-       $(docpng) \
+       tools/vcluster-setup.in \
        $(docrst) \
        doc/conf.py \
+       doc/css/style.css \
        doc/html \
        $(BUILT_EXAMPLES:%=%.in) \
        doc/examples/ganeti.default \
@@ -663,9 +825,9 @@ EXTRA_DIST = \
        doc/examples/gnt-debug/README \
        doc/examples/gnt-debug/delay0.json \
        doc/examples/gnt-debug/delay50.json \
-       test/lockperf.py \
-       test/testutils.py \
-       test/mocks.py \
+       test/py/lockperf.py \
+       test/py/testutils.py \
+       test/py/mocks.py \
        $(dist_TESTS) \
        $(TEST_FILES) \
        man/footer.rst \
@@ -673,37 +835,43 @@ EXTRA_DIST = \
        $(maninput) \
        qa/qa-sample.json \
        $(qa_scripts) \
-       $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
+       $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
        $(HS_PROG_SRCS) \
-       htools/lint-hints.hs \
-       htools/cli-tests-defs.sh \
-       htools/offline-test.sh
+       src/lint-hints.hs \
+       test/hs/cli-tests-defs.sh \
+       test/hs/offline-test.sh \
+       .ghci
 
 man_MANS = \
-       man/ganeti.7 \
        man/ganeti-cleaner.8 \
        man/ganeti-confd.8 \
        man/ganeti-listrunner.8 \
        man/ganeti-masterd.8 \
        man/ganeti-noded.8 \
        man/ganeti-os-interface.7 \
+       man/ganeti-extstorage-interface.7 \
        man/ganeti-rapi.8 \
        man/ganeti-watcher.8 \
+       man/ganeti.7 \
        man/gnt-backup.8 \
        man/gnt-cluster.8 \
        man/gnt-debug.8 \
        man/gnt-group.8 \
+       man/gnt-network.8 \
        man/gnt-instance.8 \
        man/gnt-job.8 \
        man/gnt-node.8 \
        man/gnt-os.8 \
+       man/gnt-storage.8 \
        man/hail.1 \
        man/hbal.1 \
        man/hcheck.1 \
        man/hinfo.1 \
        man/hscan.1 \
        man/hspace.1 \
-       man/htools.1
+       man/hroller.1 \
+       man/htools.1 \
+       man/mon-collector.7
 
 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
 manhtml = $(patsubst %.rst,%.html,$(manrst))
@@ -711,15 +879,47 @@ mangen = $(patsubst %.rst,%.gen,$(manrst))
 maninput = \
        $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
        $(patsubst %.html,%.html.in,$(manhtml)) \
-       man/footer.man man/footer.html $(mangen)
+       $(mangen)
 
 TEST_FILES = \
+       test/data/htools/clean-nonzero-score.data \
+       test/data/htools/common-suffix.data \
+       test/data/htools/empty-cluster.data \
+       test/data/htools/hail-alloc-drbd.json \
+       test/data/htools/hail-change-group.json \
+       test/data/htools/hail-invalid-reloc.json \
+       test/data/htools/hail-node-evac.json \
+       test/data/htools/hail-reloc-drbd.json \
+       test/data/htools/hbal-excl-tags.data \
+       test/data/htools/hbal-split-insts.data \
+       test/data/htools/invalid-node.data \
+       test/data/htools/missing-resources.data \
+       test/data/htools/n1-failure.data \
+       test/data/htools/rapi/groups.json \
+       test/data/htools/rapi/info.json \
+       test/data/htools/rapi/instances.json \
+       test/data/htools/rapi/nodes.json \
+       test/hs/shelltests/htools-balancing.test \
+       test/hs/shelltests/htools-basic.test \
+       test/hs/shelltests/htools-dynutil.test \
+       test/hs/shelltests/htools-excl.test \
+       test/hs/shelltests/htools-hail.test \
+       test/hs/shelltests/htools-hspace.test \
+       test/hs/shelltests/htools-invalid.test \
+       test/hs/shelltests/htools-multi-group.test \
+       test/hs/shelltests/htools-no-backend.test \
+       test/hs/shelltests/htools-rapi.test \
+       test/hs/shelltests/htools-single-group.test \
+       test/hs/shelltests/htools-text-backend.test \
+       test/hs/shelltests/htools-mon-collector.test \
        test/data/bdev-drbd-8.0.txt \
        test/data/bdev-drbd-8.3.txt \
        test/data/bdev-drbd-disk.txt \
        test/data/bdev-drbd-net-ip4.txt \
        test/data/bdev-drbd-net-ip6.txt \
        test/data/cert1.pem \
+       test/data/cert2.pem \
+       test/data/instance-minor-pairing.txt \
        test/data/ip-addr-show-dummy0.txt \
        test/data/ip-addr-show-lo-ipv4.txt \
        test/data/ip-addr-show-lo-ipv6.txt \
@@ -727,30 +927,10 @@ TEST_FILES = \
        test/data/ip-addr-show-lo-oneline-ipv6.txt \
        test/data/ip-addr-show-lo-oneline.txt \
        test/data/ip-addr-show-lo.txt \
-       test/data/proc_drbd8.txt \
-       test/data/proc_drbd80-emptyline.txt \
-       test/data/proc_drbd83.txt \
-       test/data/proc_drbd83_sync.txt \
-       test/data/proc_drbd83_sync_krnl2.6.39.txt \
-       test/data/kvm_1.0_help.txt \
-       test/data/kvm_0.15.90_help.txt \
        test/data/kvm_0.12.5_help.txt \
+       test/data/kvm_0.15.90_help.txt \
        test/data/kvm_0.9.1_help.txt \
-       test/data/sys_drbd_usermode_helper.txt \
-       test/data/htools/hail-alloc-drbd.json \
-       test/data/htools/hail-change-group.json \
-       test/data/htools/hail-invalid-reloc.json \
-       test/data/htools/hail-node-evac.json \
-       test/data/htools/hail-reloc-drbd.json \
-       test/data/htools/hbal-excl-tags.data \
-       test/data/htools/hbal-split-insts.data \
-       test/data/htools/common-suffix.data \
-       test/data/htools/invalid-node.data \
-       test/data/htools/missing-resources.data \
-       test/data/htools/rapi/groups.json \
-       test/data/htools/rapi/info.json \
-       test/data/htools/rapi/instances.json \
-       test/data/htools/rapi/nodes.json \
+       test/data/kvm_1.0_help.txt \
        test/data/ovfdata/compr_disk.vmdk.gz \
        test/data/ovfdata/config.ini \
        test/data/ovfdata/corrupted_resources.ovf \
@@ -764,127 +944,135 @@ TEST_FILES = \
        test/data/ovfdata/no_disk_in_ref.ovf \
        test/data/ovfdata/no_os.ini \
        test/data/ovfdata/no_ovf.ova \
+       test/data/ovfdata/other/rawdisk.raw \
        test/data/ovfdata/ova.ova \
-       test/data/ovfdata/second_disk.vmdk \
        test/data/ovfdata/rawdisk.raw \
+       test/data/ovfdata/second_disk.vmdk \
        test/data/ovfdata/unsafe_path.ini \
        test/data/ovfdata/virtualbox.ovf \
-       test/data/ovfdata/wrong_extension.ovd \
        test/data/ovfdata/wrong_config.ini \
+       test/data/ovfdata/wrong_extension.ovd \
        test/data/ovfdata/wrong_manifest.mf \
        test/data/ovfdata/wrong_manifest.ovf \
        test/data/ovfdata/wrong_ova.ova \
        test/data/ovfdata/wrong_xml.ovf \
-       test/data/ovfdata/other/rawdisk.raw \
+       test/data/proc_drbd8.txt \
+       test/data/proc_drbd80-emptyline.txt \
+       test/data/proc_drbd83.txt \
+       test/data/proc_drbd83_sync.txt \
+       test/data/proc_drbd83_sync_want.txt \
+       test/data/proc_drbd83_sync_krnl2.6.39.txt \
+       test/data/sys_drbd_usermode_helper.txt \
        test/data/vgreduce-removemissing-2.02.02.txt \
        test/data/vgreduce-removemissing-2.02.66-fail.txt \
        test/data/vgreduce-removemissing-2.02.66-ok.txt \
        test/data/vgs-missing-pvs-2.02.02.txt \
        test/data/vgs-missing-pvs-2.02.66.txt \
-       test/import-export_unittest-helper \
-       test/gnt-cli.test \
-       test/ganeti-cli.test \
-       test/htools-balancing.test \
-       test/htools-basic.test \
-       test/htools-dynutil.test \
-       test/htools-excl.test \
-       test/htools-hail.test \
-       test/htools-hspace.test \
-       test/htools-invalid.test \
-       test/htools-multi-group.test \
-       test/htools-no-backend.test \
-       test/htools-rapi.test \
-       test/htools-single-group.test \
-       test/htools-text-backend.test
+       test/py/ganeti-cli.test \
+       test/py/gnt-cli.test \
+       test/py/import-export_unittest-helper
 
 python_tests = \
        doc/examples/rapi_testutils.py \
-       test/ganeti.asyncnotifier_unittest.py \
-       test/ganeti.backend_unittest.py \
-       test/ganeti.bdev_unittest.py \
-       test/ganeti.cli_unittest.py \
-       test/ganeti.client.gnt_cluster_unittest.py \
-       test/ganeti.client.gnt_instance_unittest.py \
-       test/ganeti.daemon_unittest.py \
-       test/ganeti.cmdlib_unittest.py \
-       test/ganeti.compat_unittest.py \
-       test/ganeti.confd.client_unittest.py \
-       test/ganeti.config_unittest.py \
-       test/ganeti.constants_unittest.py \
-       test/ganeti.errors_unittest.py \
-       test/ganeti.hooks_unittest.py \
-       test/ganeti.ht_unittest.py \
-       test/ganeti.http_unittest.py \
-       test/ganeti.hypervisor_unittest.py \
-       test/ganeti.hypervisor.hv_chroot_unittest.py \
-       test/ganeti.hypervisor.hv_fake_unittest.py \
-       test/ganeti.hypervisor.hv_kvm_unittest.py \
-       test/ganeti.hypervisor.hv_lxc_unittest.py \
-       test/ganeti.hypervisor.hv_xen_unittest.py \
-       test/ganeti.impexpd_unittest.py \
-       test/ganeti.jqueue_unittest.py \
-       test/ganeti.locking_unittest.py \
-       test/ganeti.luxi_unittest.py \
-       test/ganeti.masterd.instance_unittest.py \
-       test/ganeti.mcpu_unittest.py \
-       test/ganeti.netutils_unittest.py \
-       test/ganeti.objects_unittest.py \
-       test/ganeti.opcodes_unittest.py \
-       test/ganeti.ovf_unittest.py \
-       test/ganeti.qlang_unittest.py \
-       test/ganeti.query_unittest.py \
-       test/ganeti.rapi.baserlib_unittest.py \
-       test/ganeti.rapi.client_unittest.py \
-       test/ganeti.rapi.resources_unittest.py \
-       test/ganeti.rapi.rlib2_unittest.py \
-       test/ganeti.rapi.testutils_unittest.py \
-       test/ganeti.rpc_unittest.py \
-       test/ganeti.runtime_unittest.py \
-       test/ganeti.serializer_unittest.py \
-       test/ganeti.ssh_unittest.py \
-       test/ganeti.storage_unittest.py \
-       test/ganeti.tools.ensure_dirs_unittest.py \
-       test/ganeti.uidpool_unittest.py \
-       test/ganeti.utils.algo_unittest.py \
-       test/ganeti.utils.filelock_unittest.py \
-       test/ganeti.utils.hash_unittest.py \
-       test/ganeti.utils.io_unittest.py \
-       test/ganeti.utils.log_unittest.py \
-       test/ganeti.utils.mlock_unittest.py \
-       test/ganeti.utils.nodesetup_unittest.py \
-       test/ganeti.utils.process_unittest.py \
-       test/ganeti.utils.retry_unittest.py \
-       test/ganeti.utils.text_unittest.py \
-       test/ganeti.utils.wrapper_unittest.py \
-       test/ganeti.utils.x509_unittest.py \
-       test/ganeti.utils_unittest.py \
-       test/ganeti.workerpool_unittest.py \
-       test/qa.qa_config_unittest.py \
-       test/cfgupgrade_unittest.py \
-       test/docs_unittest.py \
-       test/pycurl_reset_unittest.py \
-       test/tempfile_fork_unittest.py
-if HAS_FAKEROOT
-python_tests += test/ganeti.utils.io_unittest-runasroot.py
-endif
-
-haskell_tests = htools/test
+       test/py/cfgupgrade_unittest.py \
+       test/py/docs_unittest.py \
+       test/py/ganeti.asyncnotifier_unittest.py \
+       test/py/ganeti.backend_unittest-runasroot.py \
+       test/py/ganeti.backend_unittest.py \
+       test/py/ganeti.bdev_unittest.py \
+       test/py/ganeti.cli_unittest.py \
+       test/py/ganeti.client.gnt_cluster_unittest.py \
+       test/py/ganeti.client.gnt_instance_unittest.py \
+       test/py/ganeti.client.gnt_job_unittest.py \
+       test/py/ganeti.cmdlib_unittest.py \
+       test/py/ganeti.compat_unittest.py \
+       test/py/ganeti.confd.client_unittest.py \
+       test/py/ganeti.config_unittest.py \
+       test/py/ganeti.constants_unittest.py \
+       test/py/ganeti.daemon_unittest.py \
+       test/py/ganeti.errors_unittest.py \
+       test/py/ganeti.hooks_unittest.py \
+       test/py/ganeti.ht_unittest.py \
+       test/py/ganeti.http_unittest.py \
+       test/py/ganeti.hypervisor.hv_chroot_unittest.py \
+       test/py/ganeti.hypervisor.hv_fake_unittest.py \
+       test/py/ganeti.hypervisor.hv_kvm_unittest.py \
+       test/py/ganeti.hypervisor.hv_lxc_unittest.py \
+       test/py/ganeti.hypervisor.hv_xen_unittest.py \
+       test/py/ganeti.hypervisor_unittest.py \
+       test/py/ganeti.impexpd_unittest.py \
+       test/py/ganeti.jqueue_unittest.py \
+       test/py/ganeti.jstore_unittest.py \
+       test/py/ganeti.locking_unittest.py \
+       test/py/ganeti.luxi_unittest.py \
+       test/py/ganeti.masterd.iallocator_unittest.py \
+       test/py/ganeti.masterd.instance_unittest.py \
+       test/py/ganeti.mcpu_unittest.py \
+       test/py/ganeti.netutils_unittest.py \
+       test/py/ganeti.objects_unittest.py \
+       test/py/ganeti.objectutils_unittest.py \
+       test/py/ganeti.opcodes_unittest.py \
+       test/py/ganeti.ovf_unittest.py \
+       test/py/ganeti.qlang_unittest.py \
+       test/py/ganeti.query_unittest.py \
+       test/py/ganeti.rapi.baserlib_unittest.py \
+       test/py/ganeti.rapi.client_unittest.py \
+       test/py/ganeti.rapi.resources_unittest.py \
+       test/py/ganeti.rapi.rlib2_unittest.py \
+       test/py/ganeti.rapi.testutils_unittest.py \
+       test/py/ganeti.rpc_unittest.py \
+       test/py/ganeti.runtime_unittest.py \
+       test/py/ganeti.serializer_unittest.py \
+       test/py/ganeti.server.rapi_unittest.py \
+       test/py/ganeti.ssconf_unittest.py \
+       test/py/ganeti.ssh_unittest.py \
+       test/py/ganeti.storage_unittest.py \
+       test/py/ganeti.tools.ensure_dirs_unittest.py \
+       test/py/ganeti.tools.node_daemon_setup_unittest.py \
+       test/py/ganeti.tools.prepare_node_join_unittest.py \
+       test/py/ganeti.uidpool_unittest.py \
+       test/py/ganeti.utils.algo_unittest.py \
+       test/py/ganeti.utils.filelock_unittest.py \
+       test/py/ganeti.utils.hash_unittest.py \
+       test/py/ganeti.utils.io_unittest-runasroot.py \
+       test/py/ganeti.utils.io_unittest.py \
+       test/py/ganeti.utils.log_unittest.py \
+       test/py/ganeti.utils.lvm_unittest.py \
+       test/py/ganeti.utils.mlock_unittest.py \
+       test/py/ganeti.utils.nodesetup_unittest.py \
+       test/py/ganeti.utils.process_unittest.py \
+       test/py/ganeti.utils.retry_unittest.py \
+       test/py/ganeti.utils.text_unittest.py \
+       test/py/ganeti.utils.wrapper_unittest.py \
+       test/py/ganeti.utils.x509_unittest.py \
+       test/py/ganeti.utils_unittest.py \
+       test/py/ganeti.vcluster_unittest.py \
+       test/py/ganeti.workerpool_unittest.py \
+       test/py/pycurl_reset_unittest.py \
+       test/py/qa.qa_config_unittest.py \
+       test/py/tempfile_fork_unittest.py
+
+haskell_tests = test/hs/htest
 
 dist_TESTS = \
-       test/check-cert-expired_unittest.bash \
-       test/daemon-util_unittest.bash \
-       test/ganeti-cleaner_unittest.bash \
-       test/import-export_unittest.bash \
-       test/cli-test.bash \
+       test/py/check-cert-expired_unittest.bash \
+       test/py/daemon-util_unittest.bash \
+       test/py/ganeti-cleaner_unittest.bash \
+       test/py/import-export_unittest.bash \
+       test/py/cli-test.bash \
+       test/py/bash_completion.bash \
        $(python_tests)
 
 nodist_TESTS =
 check_SCRIPTS =
 
-if WANT_HTOOLSTESTS
+if WANT_HSTESTS
 nodist_TESTS += $(haskell_tests)
-dist_TESTS += htools/offline-test.sh
-check_SCRIPTS += htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
+dist_TESTS += test/hs/offline-test.sh
+check_SCRIPTS += \
+       test/hs/hpc-htools \
+       test/hs/hpc-mon-collector \
+       $(HS_BUILT_TEST_HELPERS)
 endif
 
 TESTS = $(dist_TESTS) $(nodist_TESTS)
@@ -905,6 +1093,7 @@ all_python_code = \
        $(python_scripts) \
        $(pkglib_python_scripts) \
        $(nodist_pkglib_python_scripts) \
+       $(nodist_tools_python_scripts) \
        $(python_tests) \
        $(pkgpython_PYTHON) \
        $(client_PYTHON) \
@@ -923,15 +1112,16 @@ all_python_code = \
 
 srclink_files = \
        man/footer.rst \
-       test/check-cert-expired_unittest.bash \
-       test/daemon-util_unittest.bash \
-       test/ganeti-cleaner_unittest.bash \
-       test/import-export_unittest.bash \
-       test/cli-test.bash \
-       htools/offline-test.sh \
-       htools/cli-tests-defs.sh \
+       test/py/check-cert-expired_unittest.bash \
+       test/py/daemon-util_unittest.bash \
+       test/py/ganeti-cleaner_unittest.bash \
+       test/py/import-export_unittest.bash \
+       test/py/cli-test.bash \
+       test/py/bash_completion.bash \
+       test/hs/offline-test.sh \
+       test/hs/cli-tests-defs.sh \
        $(all_python_code) \
-       $(HS_LIB_SRCS) $(HS_PROG_SRCS)
+       $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
 
 check_python_code = \
        $(BUILD_BASH_COMPLETION) \
@@ -968,93 +1158,76 @@ pep8_python_code = \
        $(PYTHON_BOOTSTRAP) \
        qa
 
-test/daemon-util_unittest.bash: daemons/daemon-util
+test/py/daemon-util_unittest.bash: daemons/daemon-util
 
-test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
+test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
+
+test/py/bash_completion.bash: doc/examples/bash_completion-debug
 
 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
        chmod +x $@
 
-devel/upload: devel/upload.in $(REPLACE_VARS_SED)
-       sed -f $(REPLACE_VARS_SED) < $< > $@
-       chmod u+x $@
-
-daemons/%: daemons/%.in $(REPLACE_VARS_SED)
+tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
        chmod +x $@
 
-doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
+daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
+       chmod +x $@
 
-doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
+doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
 
-doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
-       lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
-       PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
+doc/examples/bash_completion: BC_ARGS = --compact
+doc/examples/bash_completion-debug: BC_ARGS =
 
-doc/%.png: doc/%.dot
-       @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
-       $(DOT) -Tpng -o $@ $<
-
-man/footer.man: man/footer.rst
-       @test -n "$(PANDOC)" || \
-         { echo 'pandoc' not found during configure; exit 1; }
-       $(PANDOC) -f rst -t man -o $@ $<
-
-man/footer.html: man/footer.rst
-       @test -n "$(PANDOC)" || \
-         { echo 'pandoc' not found during configure; exit 1; }
-       $(PANDOC) -f rst -t html -o $@ $<
+doc/examples/bash_completion doc/examples/bash_completion-debug: \
+       $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
+       lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
+       daemons/ganeti-cleaner \
+       $(GENERATED_FILES) $(HS_GENERATED_FILES)
+       PYTHONPATH=. $(RUN_IN_TEMPDIR) \
+         $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
 
 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
        lib/build/shell_example_lexer.py \
        | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
        @echo "Checking $< for hardcoded paths..."
        @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
-         echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
+         echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
          exit 1; \
        fi
        set -e ; \
        trap 'echo auto-removing $@; rm $@' EXIT; \
        PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
+       $(CHECK_MAN_REFERENCES) $@; \
        trap - EXIT
 
-man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
+man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
        @test -n "$(PANDOC)" || \
          { echo 'pandoc' not found during configure; exit 1; }
        set -o pipefail ; \
        trap 'echo auto-removing $@; rm $@' EXIT; \
-       $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
+       $(PANDOC) -s -f rst -t man $< man/footer.rst | \
          sed -e 's/\\@/@/g' > $@; \
        if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
        $(CHECK_MAN_DASHES) $@; \
        trap - EXIT
 
-
-man/%.html.in: man/%.gen man/footer.html
+man/%.html.in: man/%.gen man/footer.rst
        @test -n "$(PANDOC)" || \
          { echo 'pandoc' not found during configure; exit 1; }
        set -o pipefail ; \
-       $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
+       $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
          sed -e 's/\\@/@/g' > $@
 
-man/%.1: man/%.1.in $(REPLACE_VARS_SED)
-       sed -f $(REPLACE_VARS_SED) < $< > $@
-
-man/%.7: man/%.7.in $(REPLACE_VARS_SED)
-       sed -f $(REPLACE_VARS_SED) < $< > $@
-
-man/%.8: man/%.8.in $(REPLACE_VARS_SED)
+man/%: man/%.in  $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
 
-man/%.html: man/%.html.in $(REPLACE_VARS_SED)
+epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
 
-epydoc.conf: epydoc.conf.in Makefile
-       sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
-
 vcs-version:
        if test -d .git; then \
          git describe > $@; \
@@ -1068,26 +1241,43 @@ clean-vcs-version:
 
 .PHONY: regen-vcs-version
 regen-vcs-version:
-       set -e; \
+       @set -e; \
        cd $(srcdir); \
        if test -d .git; then \
-         $(MAKE) clean-vcs-version; \
-         $(MAKE) vcs-version; \
+         T=`mktemp` ; trap 'rm -f $$T' EXIT; \
+         git describe > $$T; \
+         if ! cmp --quiet $$T vcs-version; then \
+           mv $$T vcs-version; \
+         fi; \
        fi
 
-htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
+src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
+       vcs-version $(built_base_sources)
        set -e; \
        VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
        sed -e "s/%ver%/$$VCSVER/" < $< > $@
 
-htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
-       lib/constants.py lib/_autoconf.py lib/luxi.py \
-       $(CONVERT_CONSTANTS) \
+src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
+       lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
+       lib/jstore.py $(RUN_IN_TEMPDIR) \
+       $(CONVERT_CONSTANTS) $(built_base_sources) \
        | lib/_vcsversion.py
        set -e; \
-       { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
+       { cat $< ; \
+         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
+       } > $@
 
-lib/_autoconf.py: Makefile | lib/.dir
+test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
+       $(built_base_sources)
+       set -e; \
+       { cat $< ; \
+         echo ; \
+         for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
+           echo "import $$name ()" ; \
+         done ; \
+       } > $@
+
+lib/_autoconf.py: Makefile | stamp-directories
        set -e; \
        { echo '# This file is automatically generated, do not edit!'; \
          echo '#'; \
@@ -1113,8 +1303,11 @@ lib/_autoconf.py: Makefile | lib/.dir
          echo "LOCALSTATEDIR = '$(localstatedir)'"; \
          echo "SYSCONFDIR = '$(sysconfdir)'"; \
          echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
+         echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
+         echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
          echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
          echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
+         echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
          echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
          echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
          echo "XEN_INITRD = '$(XEN_INITRD)'"; \
@@ -1132,6 +1325,7 @@ lib/_autoconf.py: Makefile | lib/.dir
          echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
          echo "TOOLSDIR = '$(toolsdir)'"; \
          echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
+         echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
          echo "PKGLIBDIR = '$(pkglibdir)'"; \
          echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
          echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
@@ -1148,18 +1342,15 @@ lib/_autoconf.py: Makefile | lib/.dir
          echo "NODED_GROUP = '$(NODED_GROUP)'"; \
          echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
          echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
-         if [ "$(HTOOLS)" ]; then \
-           echo "HTOOLS = True"; \
-         else \
-           echo "HTOOLS = False"; \
-         fi; \
+         echo "HTOOLS = True"; \
          echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
-         echo "PY_CONFD = $(PY_CONFD)"; \
-         echo "HS_CONFD = $(HS_CONFD)"; \
          echo "XEN_CMD = '$(XEN_CMD)'"; \
+         echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
+         echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
+         echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
        } > $@
 
-lib/_vcsversion.py: Makefile vcs-version | lib/.dir
+lib/_vcsversion.py: Makefile vcs-version | stamp-directories
        set -e; \
        VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
        { echo '# This file is automatically generated, do not edit!'; \
@@ -1183,13 +1374,27 @@ lib/_vcsversion.py: Makefile vcs-version | lib/.dir
 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
        PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
 
-$(REPLACE_VARS_SED): Makefile
+$(SHELL_ENV_INIT): Makefile stamp-directories
+       set -e; \
+       { echo '# Allow overriding for tests'; \
+         echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
+         echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
+         echo; \
+         echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
+         echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
+         echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
+         echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
+         echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
+       } > $@
+
+$(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
        set -e; \
        { echo 's#@PREFIX@#$(prefix)#g'; \
          echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
          echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
          echo 's#@BINDIR@#$(bindir)#g'; \
          echo 's#@SBINDIR@#$(sbindir)#g'; \
+         echo 's#@LIBDIR@#$(libdir)#g'; \
          echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
          echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
          echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
@@ -1209,6 +1414,13 @@ $(REPLACE_VARS_SED): Makefile
          echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
          echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
          echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
+         echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
+         echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
+         echo; \
+         echo '/^@SHELL_ENV_INIT@$$/ {'; \
+         echo '  r $(SHELL_ENV_INIT)'; \
+         echo '  d'; \
+         echo '}'; \
        } > $@
 
 # Using deferred evaluation
@@ -1216,9 +1428,12 @@ daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
 daemons/ganeti-watcher: MODULE = ganeti.watcher
 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
-$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/%,%,$@)
+tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
+tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
+tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
+$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
 
-$(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
+$(PYTHON_BOOTSTRAP): Makefile | stamp-directories
        test -n "$(MODULE)" || { echo Missing module; exit 1; }
        set -e; \
        { echo '#!/usr/bin/python'; \
@@ -1252,18 +1467,23 @@ $(HS_BUILT_TEST_HELPERS): Makefile
          echo '# This file is automatically generated, do not edit!'; \
          echo "# Edit Makefile.am instead."; \
          echo; \
-         echo "HTOOLS=$(TESTROLE) exec ./htools/hpc-htools \"\$$@\""; \
+         echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
        } > $@
        chmod u+x $@
 
+stamp-directories: Makefile
+       $(MAKE) $(AM_MAKEFLAGS) ganeti
+       @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
+       touch $@
+
 # We need to create symlinks because "make distcheck" will not install Python
 # files when building.
-stamp-srclinks: Makefile | $(all_dirfiles)
+stamp-srclinks: Makefile | stamp-directories
        set -e; \
        for i in $(srclink_files); do \
-               if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
-                       $(LN_S) $(abs_top_srcdir)/$$i $$i; \
-               fi; \
+         if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
+           $(LN_S) $(abs_top_srcdir)/$$i $$i; \
+         fi; \
        done
        touch $@
 
@@ -1272,53 +1492,75 @@ ganeti:
        cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
 
 .PHONY: check-dirs
-check-dirs: $(BUILT_SOURCES)
+check-dirs: $(GENERATED_FILES)
        @set -e; \
-       find . -type d \( \( -name . \) -o \( \
-               -name .git -o \
-               -name autom4te.cache \
-               \) -prune -o -print \) | { \
-               error=; \
-               while read dir; do \
-                       case "$$dir" in \
-                               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
-                               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
-                       esac; \
-               done; \
-               for dir in $(DIRS); do \
-                       if ! test -d "$$dir"; then \
-                               echo "Directory $$dir listed in DIRS does not exist" >&2; \
-                               error=1; \
-                       fi \
-               done; \
-               if test -n "$$error"; then exit 1; else exit 0; fi; \
+       find . -type d \( -name . -o -name .git -prune -o -print \) | { \
+         error=; \
+         while read dir; do \
+           case "$$dir" in \
+             $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
+             *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
+           esac; \
+         done; \
+         for dir in $(DIRS); do \
+           if ! test -d "$$dir"; then \
+             echo "Directory $$dir listed in DIRS does not exist" >&2; \
+             error=1; \
+           fi \
+         done; \
+         test -z "$$error"; \
        }
 
 .PHONY: check-local
-check-local: check-dirs $(BUILT_SOURCES)
+check-local: check-dirs $(GENERATED_FILES)
        $(CHECK_PYTHON_CODE) $(check_python_code)
        PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
        $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
        $(CHECK_NEWS) < $(top_srcdir)/NEWS
        PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
-       expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
+       @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
+       error= ; \
        if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
-               echo "Incorrect version in README, expected $$expver"; \
-               exit 1; \
+         echo "Incorrect version in README, expected $$expver" >&2; \
+         error=1; \
        fi; \
-       for file in doc/iallocator.rst doc/hooks.rst; do \
-               if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
-                       "Documents Ganeti version $$expver"; then \
-                       echo "Incorrect version in $$file, expected $$expver"; \
-                       exit 1; \
-               fi; \
-       done
+       for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
+           doc/security.rst; do \
+         if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
+           "Documents Ganeti version $$expver"; then \
+           echo "Incorrect version in $$file, expected $$expver" >&2; \
+           error=1; \
+         fi; \
+       done; \
+       if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
+         echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
+         error=1; \
+       fi; \
+       if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
+         ".. Last updated for Ganeti $$expver"; then \
+         echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
+         error=1; \
+       fi; \
+       for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
+         if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
+           echo "Longest line in $$file is longer than 80 characters" >&2; \
+           error=1; \
+         fi; \
+       done; \
+       test -z "$$error"
+
+.PHONY: hs-tests
+hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
+       @rm -f htest.tix
+       ./test/hs/htest
+
+.PHONY: hs-shell
+hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
+       @rm -f hpc-htools.tix hpc-mon-collector.tix
+       HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
 
 .PHONY: hs-check
-hs-check: htools/test htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
-       @rm -f test.tix
-       ./htools/test
-       HBINARY="./htools/hpc-htools" ./htools/offline-test.sh
+hs-check: hs-tests hs-shell
 
 # E111: indentation is not a multiple of four
 # E121: continuation line indentation is not a multiple of four
@@ -1327,11 +1569,13 @@ hs-check: htools/test htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
 #       (since our indent level is not 4)
 # E127: continuation line over-indented for visual indent
 #       (since our indent level is not 4)
-# E122,E123,E126,E128,E262,E272,E502,E711,: added temporarily to not
-#       modify stable code; do NOT merge these into master!
+# note: do NOT add E128 here; it's a valid style error in most cases!
+# I've seen real errors, but also some cases were we indent wrongly
+# due to line length; try to rework the cases where it is triggered,
+# instead of silencing it
 # E261: at least two spaces before inline comment
 # E501: line too long (80 characters)
-PEP8_IGNORE = E111,E121,E122,E123,E125,E126,E127,E128,E261,E262,E272,E501,E502,E711
+PEP8_IGNORE = E111,E121,E125,E127,E261,E501
 
 # For excluding pep8 expects filenames only, not whole paths
 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
@@ -1348,69 +1592,71 @@ endif
 lint: $(LINT_TARGETS)
 
 .PHONY: pylint
-pylint: $(BUILT_SOURCES)
+pylint: $(GENERATED_FILES)
        @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
        $(PYLINT) $(LINT_OPTS) $(lint_python_code)
 
 .PHONY: pylint-qa
-pylint-qa: $(BUILT_SOURCES)
+pylint-qa: $(GENERATED_FILES)
        @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
        cd $(top_srcdir)/qa && \
          PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
          --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
 
 .PHONY: pep8
-pep8: $(BUILT_SOURCES)
+pep8: $(GENERATED_FILES)
        @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
        $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
-               --repeat $(pep8_python_code)
+         --repeat $(pep8_python_code)
 
+# FIXME: remove ignore "Use void" when GHC 6.x is deprecated
+HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
 .PHONY: hlint
-hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
+hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
        @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
        if tty -s; then C="-c"; else C=""; fi; \
-       $(HLINT) --report=doc/hs-lint.html --cross $$C \
+       $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
          --ignore "Use first" \
-         --ignore "Use comparing" \
-         --ignore "Use on" \
+         --ignore "Use &&&" \
+         --ignore "Use void" \
          --ignore "Reduce duplication" \
-         --hint htools/lint-hints \
-         $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
+         --hint src/lint-hints \
+         $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
 
 # a dist hook rule for updating the vcs-version file; this is
 # hardcoded due to where it needs to build the file...
 dist-hook:
-       $(MAKE) regen-vcs-version
+       $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
        rm -f $(top_distdir)/vcs-version
        cp -p $(srcdir)/vcs-version $(top_distdir)
 
 # a distcheck hook rule for catching revision control directories
 distcheck-hook:
        if find $(top_distdir) -name .svn -or -name .git | grep .; then \
-               echo "Found revision control files in final archive." 1>&2; \
-               exit 1; \
+         echo "Found revision control files in final archive." 1>&2; \
+         exit 1; \
        fi
        if find $(top_distdir) -name '*.py[co]' | grep .; then \
-               echo "Found Python byte code in final archive." 1>&2; \
-               exit 1; \
+         echo "Found Python byte code in final archive." 1>&2; \
+         exit 1; \
        fi
        if find $(top_distdir) -name '*~' | grep .; then \
-               echo "Found backup files in final archive." 1>&2; \
-               exit 1; \
+         echo "Found backup files in final archive." 1>&2; \
+         exit 1; \
        fi
 # Empty files or directories should not be distributed. They can cause
 # unnecessary warnings for packagers. Directories used by automake during
 # distcheck must be excluded.
        if find $(top_distdir) -empty -and -not \( \
-                       -path $(top_distdir)/_build -or \
-                       -path $(top_distdir)/_inst \) | grep .; then \
-               echo "Found empty files or directories in final archive." 1>&2; \
-               exit 1; \
+           -path $(top_distdir)/_build -or \
+           -path $(top_distdir)/_inst \) | grep .; then \
+         echo "Found empty files or directories in final archive." 1>&2; \
+         exit 1; \
        fi
        if test -n "$(BUILD_RELEASE)" && \
           grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
-               echo "Found unreleased version in NEWS." >&2; \
-               exit 1; \
+          echo "Found unreleased version in NEWS." >&2; \
+          exit 1; \
        fi
 
 # When building a release, stricter checks should be used
@@ -1433,9 +1679,9 @@ distrebuildcheck: dist
 dist-release: dist
        set -e; \
        for i in $(DIST_ARCHIVES); do \
-               echo -n "Checking $$i ... "; \
-               autotools/check-tar < $$i; \
-               echo OK; \
+         echo -n "Checking $$i ... "; \
+         autotools/check-tar < $$i; \
+         echo OK; \
        done
 
 install-exec-local:
@@ -1443,23 +1689,19 @@ install-exec-local:
          "$(DESTDIR)${localstatedir}/log/ganeti" \
          "$(DESTDIR)${localstatedir}/run/ganeti"
 
-# To avoid conflicts between directory names and other targets, a file inside
-# the directory is used to ensure its existence.
-%.dir:
-       @mkdir_p@ $* && touch $@
-
 .PHONY: apidoc
-if WANT_HTOOLSAPIDOC
+if WANT_HSAPIDOC
 apidoc: py-apidoc hs-apidoc
 else
 apidoc: py-apidoc
 endif
 
 .PHONY: py-apidoc
-py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
+py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
+       env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
        $(RUN_IN_TEMPDIR) epydoc -v \
-               --conf $(CURDIR)/epydoc.conf \
-               --output $(CURDIR)/$(APIDOC_PY_DIR)
+         --conf $(CURDIR)/epydoc.conf \
+         --output $(CURDIR)/$(APIDOC_PY_DIR)
 
 .PHONY: hs-apidoc
 hs-apidoc: $(HS_BUILT_SRCS)
@@ -1468,39 +1710,47 @@ hs-apidoc: $(HS_BUILT_SRCS)
        @test -n "$(HADDOCK)" || \
            { echo 'haddock' not found during configure; exit 1; }
        rm -rf $(APIDOC_HS_DIR)/*
-       @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
-       @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
+       for i in $(ALL_APIDOC_HS_DIRS); do \
+         @mkdir_p@ $$i; \
+       done
        $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
        $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
        $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
        set -e ; \
-       cd htools; \
-       if [ "$(HTOOLS_NOCURL)" ]; \
-       then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
+       cd src; \
+       if [ "$(HS_NOCURL)" ]; \
+       then OPTGHC="--optghc=$(HS_NOCURL)"; \
        else OPTGHC=""; \
        fi; \
-       if [ "$(HTOOLS_PARALLEL3)" ]; \
-       then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
+       if [ "$(HS_PARALLEL3)" ]; \
+       then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
        fi; \
-       RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
+       if [ "$(HS_REGEX_PCRE)" ]; \
+       then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
+       fi; \
+       RELSRCS="$(HS_LIB_SRCS:src/%=%) $(patsubst src/%,%,$(filter src/%,$(HS_BUILT_SRCS)))"; \
        for file in $$RELSRCS; do \
-               hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
-               $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
+         hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
+         $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
        done ; \
        $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
-               -t ganeti-htools -p haddock-prologue \
-               --source-module="%{MODULE/.//}.html" \
-               --source-entity="%{MODULE/.//}.html#%{NAME}" \
-               $$OPTGHC \
-               $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
+         -t ganeti -p haddock-prologue \
+         --source-module="%{MODULE/.//}.html" \
+         --source-entity="%{MODULE/.//}.html#%{NAME}" \
+         $$OPTGHC \
+         $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:src/%=%))
 
 .PHONY: TAGS
-TAGS: $(BUILT_SOURCES)
+TAGS: $(GENERATED_FILES)
        rm -f TAGS
+       $(GHC) -e ":etags" -v0 \
+         $(filter-out -O -Werror,$(HFLAGS)) \
+         $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
+         $(HS_LIBTEST_SRCS)
        find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
          -path './daemons/ganeti-*' -o -path './tools/*' -o \
          -path './qa/*.py' | \
-         etags -l python -
+         etags -l python -a -
 
 .PHONY: coverage
 if WANT_HTOOLS
@@ -1510,22 +1760,27 @@ coverage: py-coverage
 endif
 
 .PHONY: py-coverage
-py-coverage: $(BUILT_SOURCES) $(python_tests)
+py-coverage: $(GENERATED_FILES) $(python_tests)
+       @test -n "$(PYCOVERAGE)" || \
+           { echo 'python-coverage' not found during configure; exit 1; }
        set -e; \
+       COVERAGE=$(PYCOVERAGE) \
        COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
        TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
        HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
-       $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
+       $(PLAIN_TESTS_ENVIRONMENT) \
+       $(abs_top_srcdir)/autotools/gen-py-coverage \
        $(python_tests)
 
 .PHONY: hs-coverage
-hs-coverage: $(haskell_tests) htools/hpc-htools
+hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
        rm -f *.tix
-       $(MAKE) hs-check
+       $(MAKE) $(AM_MAKEFLAGS) hs-check
        @mkdir_p@ $(COVERAGE_HS_DIR)
-       hpc combine $(HPCEXCL) test.tix hpc-htools.tix > coverage-htools.tix
-       hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
-       hpc report coverage-htools.tix
+       hpc sum --union $(HPCEXCL) \
+         htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
+       hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
+       hpc report coverage-hs.tix
        $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
 
 # Special "kind-of-QA" target for htools, needs special setup (all
@@ -1533,15 +1788,15 @@ hs-coverage: $(haskell_tests) htools/hpc-htools
 .PHONY: live-test
 live-test: all
        set -e ; \
-       cd htools; \
+       cd src; \
        rm -f .hpc; $(LN_S) ../.hpc .hpc; \
        rm -f *.tix *.mix; \
        ./live-test.sh; \
-       hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
+       hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
          --output=live-test.tix ; \
        @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
        hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
-               --srcdir=.. $(HPCEXCL) ; \
+         --srcdir=.. $(HPCEXCL) ; \
        hpc report --srcdir=.. live-test $(HPCEXCL)
 
 commit-check: distcheck lint apidoc
@@ -1554,6 +1809,22 @@ gitignore-check:
          exit 1; \
        fi
 
+# target to rebuild all man pages (both groff and html output)
+.PHONY: man
+man: $(man_MANS) $(manhtml)
+
+# Target that builds all binaries (including those that are not
+# rebuilt except when running the tests)
+.PHONY: really-all
+really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
+
+# we don't need the ancient implicit rules:
+%: %,v
+%: RCS/%,v
+%: RCS/%
+%: s.%
+%: SCCS/s.%
+
 -include ./Makefile.local
 
 # vim: set noet :